#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>

#ifndef FAR
#define FAR
#endif

#ifndef HUGE
#define HUGE
#endif

#define KXLINES 6
#define MaxLines 1000            /* max number of lines in input file */
#define MaxFileSize 100000L     /* Maximum file size */
#define PageSize 18 			/* number of lines displayed per screen */
#define MaxDictSize 200000L 	/* max number of bytes in dictionary */

extern char    *getenv();

/* Since accessing video directly required more changes, just copy
 * the entire screen into a virtual screen buffer and work on that
 * copy when reading from screen.
 */
char VidPtr[4096]; /* 80 columns 25 columns char+attr => 80*25*2 */

/* Added: Joel Chen  Compound Size Constants */

#define COMP_SIZE  7
#define COMP_CCNUM (COMP_SIZE*2+1)  /* number of Chinese chars in the compound */
#define FIRST_BYTE_CLICK_POS (COMP_CCNUM-1)
unsigned char	ChnComp[COMP_CCNUM * 2 + 2];
 /* the Chinese compound pointed to by the mouse */

int HzOff = 0; /* If using HZ, this is 2 so to step over the "~{" */
char *HzOnMark = "~{";
char *HzOffMark = "~}";

int 			CompIdx;		/* Index point to current Chinese character
								 * in the compound */
/* Done Added: Joel Chen  Compound Size Constants */

/* file contents, line spearated by '\n' */
unsigned char HUGE  Line[MaxFileSize], *FileData = Line, *EndData;

/* note:  an extra byte is allocated for a terminating null */
unsigned char   BottomLine[KXLINES][81],    /* Last six line of the screen */
				LineBuf[81],
				BlankLine[81],
				ClickedLine[81];

/* Added: Joel Chen  Static Dict Buffers */
unsigned char HUGE Dict[MaxDictSize];	/* Chinese dictionary file */
unsigned char HUGE CompDict[MaxDictSize];  /* Chinese compound dict. file */
/* Done Added: Joel Chen  Static Dict Buffers */


int 			NLines = 0, 	/* number of lines in input file */
				TopLine = 0,	/* within-file line number for line 0 of the
								 * screen */
				OldX,			/* old x-coordinate for mouse pointer */
				OldY,			/* old y-coordinate for mouse pointer */
				NewX,			/* new x-coordinate for mouse pointer */
				NewY,			/* new y-coordinate for mouse pointer */
				OldRow, 		/* old row number for mouse pointer */
				NewRow, 		/* new row number for mouse pointer */
				OldCol, 		/* old column number for mouse pointer */
				NewCol, 		/* new column number for mouse pointer */
				LongFile = 0,	/* gone past MaxLines lines yet? */
				Big5 = 1,		/* 1 for Big5, 0 for Hz */

/* Added: Joel Chen */
                Use25thLine = 1,/* Use 25th line of the display if equal to 1 */
				ClickedCol, 	/* The column the mouse was at when user
								 * click the button. */
				KXHandleMouseCursor = 0;	/* 1 use text curosr as mouse
											 * cursor */

long			NDictChars = 0,
                NCompDictChars = 0,
                FileSize = 0; /* Size of the file reading */

char		   *InputFileName = 0;

#define BOOKMARKBEG "___KX___BOOKMARK___BEGIN___"
#define BOOKMARKEND "___KX___BOOKMARK___END___"

/* Done Added: Joel Chen */

union REGS		InRegs,
				OutRegs;
struct SREGS	SegRegs;		/* needed for int86() */

FILE		   *InFilePtr,		/* pointer to file to be viewed */
			   *DictFilePtr,	/* pointer to dictionary file */
			   *ShengziFilePtr; /* pointer to file of new characters */

/* #define _DEBUG_ */
#ifdef _DEBUG_
FILE		   *DebugPtr;
#endif


#if (!defined( __BORLANDC__ )) && (!defined( __TURBOC__ ))
#define strncmpi strnicmp
#endif

/* Function prototypes */

void			FindVidStart(void);
void			WriteCopyRight(void);
void			WriteKXLines(void);
void			InitMouse(void);
void			GetMousePosition(void);
void			ShowMouseCursor(void);
void			HideMouseCursor(void);
void			InitMouseCursor(void);
long			ReadDict(unsigned char HUGE *, char *);
void			FormLines(void);
char FAR	   *CharLoc(int, int);
void            WriteLineNum(int, unsigned char*, int);
#define WriteLine(L,S) WriteLineNum(L,S,80)
void			Refresh(void);
void			StrCpy(unsigned char *, long, unsigned char HUGE *);
int 			DoFound(long, unsigned char HUGE *, int);
int 			CheckMatch(long, unsigned char HUGE *);
int 			CompoundCmp(long);
int 			CompoundMatch(long, int *);
void			LookupComp(void);
int 			Lookup(long *, unsigned char HUGE *, long);
void			GetChnComp(void);
int 			ButtonPress(void);
void			BlankScreen(void);
void			Welcome(void);
void			Help(void);
void			CreateFileName(char *, char *);
char		   *BaseName(char *);
void			SaveBookMark(char *);
int 			ReadBookMark(char *);
void			ProcessKeyCmd(void);
void			Usage(int);
int 			ParseArgv(int, char **);
void			ReadDicts(void);
#ifdef _DEBUG_
void			OpenDebug(void);
void			CloseDebug(void);
#endif

/* Done function prototypes */


void			FindVidStart(void)
{
	printf("FindVidStart: GCC Version => not use.\n");
}


void			WriteCopyRight(void)
{
	int 			I;
	for (I = PageSize; I < 22 + Use25thLine; I++)
		WriteLine(I, BlankLine);
	strcpy(LineBuf,
		   "Queried characters recorded in shengzi.b5.  Type h for help.");
	WriteLine(22 + Use25thLine, LineBuf);
	strcpy(LineBuf, "For educational purposes only.");
	strcat(LineBuf, "  Copyright Norman Matloff, 1993.");
	WriteLine(23 + Use25thLine, LineBuf);
}


void			WriteKXLines(void)
{
	int 			I,
					J;

    for (I = PageSize + 1, J = 0; I < 24+Use25thLine && J < KXLINES; I++, J++)
		if (BottomLine[J][0] != 0)
			WriteLine(I, BottomLine[J]);
}


void			InitMouse(void)
{
	InRegs.x.ax = 0;
	int86(0x33, &InRegs, &OutRegs);

	if (!OutRegs.x.ax) {
		printf("no mouse present\n");
		exit(1);
	}
}

/* Change: Joel Chen  Mouse Handling */

void			GetMousePosition(void)
{
	InRegs.x.ax = 3;
	int86(0x33, &InRegs, &OutRegs);
	NewX = OutRegs.x.cx;
	NewY = OutRegs.x.dx;
	NewRow = NewY / 8;
	NewCol = NewX / 8;
	if ( NewRow > 24 ) NewRow = 24;
}

static int		MouseHidden = 1;

void			ShowMouseCursor(void)
{
	if (!MouseHidden)
		return;
	InRegs.x.ax = 1;
	int86(0x33, &InRegs, &OutRegs);
	MouseHidden = 0;
}

void			HideMouseCursor(void)
{
	if (MouseHidden)
		return;
	InRegs.x.ax = 2;
	int86(0x33, &InRegs, &OutRegs);
	MouseHidden = 1;
}


void			InitMouseCursor(void)
{
	if (!KXHandleMouseCursor) {
		ShowMouseCursor();
		_setcursortype( _NOCURSOR );
	} else
        _setcursortype( _SOLIDCURSOR );
	GetMousePosition();
	OldX = NewX;
	OldY = NewY;
	OldRow = NewRow;
	OldCol = NewCol;
}

/* Change: Joel Chen  Mouse Handling */


/* Change: Joel Chen  ReadDict */
long			ReadDict(unsigned char HUGE * DictPtr, char *DictN)
{
	unsigned char	DN[512];
	int 			I,
                    C,
                    TotalLine = 0;
	long			NChars = 0;
    char            AdjLines[2][20];
    int             Adj = 1, Chk = 0;

    AdjLines[0][0] = 0;

	strcpy(DN, DictN);
	if (Big5)
		strcat(DN, ".b5");
	else
		strcat(DN, ".hz");
	DictFilePtr = fopen(DN, "r");

	if (!DictFilePtr) {
		if (getenv("KXDIR")) {
			strcpy(DN, getenv("KXDIR"));
			for (I = 0; I < strlen(DN); I++)
				if (DN[I] == '\\')
					DN[I] = '/';
			strcat(DN, "/");
			strcat(DN, DictN);
			if (Big5)
				strcat(DN, ".b5");
			else
				strcat(DN, ".hz");
			DictFilePtr = fopen(DN, "r");
		}
	}
	if (!DictFilePtr) {
		printf("Missing dictionary file. %s\n", DN);
		exit(1);
	}
	printf("Reading dictionary file...\n");
	while (1) {
		if (fgets(DN, 510, DictFilePtr) == NULL)
			break;
/*		if ( (C = fgetc(DictFilePtr)) == EOF ) break; */
		I = 0;
		Chk = 0;
		while (DN[I]) {
            if ( Chk == 0 ) {
                if ( DN[I] == ' ' ) {
                    Chk = 1;
                    AdjLines[Adj][I] = 0;
                    if ( strcmp( AdjLines[Adj], AdjLines[1-Adj] ) < 0 ) {
                        printf("Error!  Dictionary not sorted.\n");
                        printf("Line %5d: \"%s\"\n", TotalLine,
                            AdjLines[1-Adj] );
                        printf("Line %5d: \"%s\"\n", TotalLine+1,
                            AdjLines[Adj] );
                        exit(1);
                    }
                } else
                    AdjLines[Adj][I] = DN[I];
			}
			DictPtr[NChars++] = (unsigned char) DN[I++];
			if (NChars >= MaxDictSize) {
				printf("Dictionary too large.\n");
				exit(1);
			}
		}
        TotalLine ++;
		Adj = 1 - Adj;
	}
    fclose(DictFilePtr);
	return NChars;
}
/* Change: Joel Chen  ReadDict */



void			FormLines(void)
{
    unsigned char   ReadBuf[512];
    unsigned char   *FD = Line;
    int             LL = 0, I;
    int LongLine = 0;   /* encountered a long line (> 80 chars) yet? */

    FileSize = 0L;

	while (1) {
        if ( fgets(ReadBuf, 510, InFilePtr ) == NULL ) break;
        LL = strlen( ReadBuf );
        FileSize += LL;
        if ( FileSize >= MaxFileSize ) {
            printf("Maximum file size exceeded; remaining lines ignored.\n");
            printf("Hit any character to continue.\n");
            getch();
            break;
        }
        if ( LL <= 80 ) {
            strcpy( FD, ReadBuf );
            FD += LL;
        } else {
            if ( !LongLine ) {
                printf("Warning: at least one line has more than 80 characters.\n");
                LongLine = 1;
                printf("Hit any character to continue.\n");
                getch();
            }
            strncpy( FD, ReadBuf, 80 );
            FD += 80;
        }
        NLines ++;
	}
    *FD = 0;
    EndData = FD;
}


char FAR	   *CharLoc(int R, int C)
{
    return VidPtr + 160 * R + 2 * C;
}


void            WriteLineNum(int LineNum, unsigned char *LineArray, int Len)
{
	int 			J;
	unsigned char FAR *P;

	HideMouseCursor();
	P = CharLoc(LineNum, 0);
    for (J = 0; J < Len; J++, P += 2) {
        if (LineArray[J] == 0) break;
		*P = LineArray[J];
	}
    for( ; J < 80; J ++, P += 2 ) *P = ' ';
    puttext( 1, LineNum+1, 80, LineNum+1, CharLoc(LineNum, 0) );
}

void FileForward( int NL )
{
    while( NL > 0 ) {
        while( *FileData++ != '\n' );
        if ( *FileData == 0 ) break;
        NL --;
    }
    if ( FileData >= EndData ) {
        FileData = EndData;
        while( *FileData-- != '\n' );
        FileData++;
    }
}

void FileBackward( int NL )
{
    NL ++;
    while( NL > 0 ) {
        while( FileData != Line && *FileData-- != '\n' );
        NL --;
    }
    if ( FileData > Line ) FileData += 2;
    if ( FileData < Line ) FileData = Line;
}

void FileGoto( int L )
{
    if ( L < 0 || L == TopLine ) return;
    if ( L > TopLine )
        FileForward( L - TopLine );
    else
        FileBackward( TopLine - L );
}


unsigned char HUGE *NextLine( unsigned char HUGE *FD, int *LL )
{
    (*LL) = 0;

    while( *FD != 0 && *FD++ != '\n' ) {
        (*LL) ++;
    }
    return FD;
}

void			Refresh(void)
{
    int             L, LL;
    unsigned char HUGE *NL, *O_NL;

    NL = O_NL = FileData;

	for (L = 0; L < PageSize; L++)
        if (TopLine + L < NLines) {
            NL = NextLine( NL, &LL );
            WriteLineNum(L, O_NL, LL );
            O_NL = NL;
        } else
			WriteLine(L, BlankLine);
	WriteCopyRight();
	WriteKXLines();
}


 /* can't use strcpy with HUGE arrays; does "strcpy" starting at Dict[I] up
  * to '\n', copying to *C */
void			StrCpy(unsigned char *C, long I, unsigned char HUGE * DictPtr)
{
	int 			J;
	long			K;

	K = I;
	for (J = 0;; J++) {
		*(C + J) = DictPtr[K++];
		if (*(C + J) == '\n') {
			*(C + J) = 0;
			return;
		}
	}
}


int 			DoFound(long I, unsigned char HUGE * DictPtr, int Row)
{
	int 			II,
					SL;
	unsigned char	Tmp[81],
					Tmp2[161];

	if (Row > (23 + Use25thLine))
		Row = 0;
	strcpy(Tmp, BlankLine);
	strcpy(Tmp2, BlankLine);
	strcpy(Tmp2 + 80, BlankLine);
	StrCpy(Tmp2, I, DictPtr);
	SL = strlen(Tmp2);
	II = (SL <= 80) ? SL : 80;
	strncpy(Tmp, Tmp2, II);
	if (Row > PageSize) {
		strncpy(BottomLine[Row - (PageSize + 1)], Tmp, 80);
	}
	WriteLine(Row++, Tmp);
	if (SL > 80) {
		strncpy(Tmp, BlankLine, 80);
		strncpy(Tmp, Tmp2 + 80, 80);
        if (Row > PageSize) {
			strncpy(BottomLine[Row - (PageSize + 1)], Tmp, 80);
		}
		WriteLine(Row++, Tmp);
	}
	fputs(Tmp2, ShengziFilePtr);
	fprintf(ShengziFilePtr, "\n");
	return Row;
}


int             CheckMatch(long J, unsigned char HUGE * DictPtr)
{
#ifdef _DEBUG_
	OpenDebug();
    fprintf(DebugPtr, "\n%s", HzOnMark );
	fputc(DictPtr[J], DebugPtr);
	fputc(DictPtr[J + 1], DebugPtr);
    fprintf(DebugPtr, "%s<>%s", HzOffMark, HzOnMark );
	fputc(ChnComp[CompIdx], DebugPtr);
	fputc(ChnComp[CompIdx + 1], DebugPtr);
    fprintf(DebugPtr, "%s\n", HzOffMark );
	CloseDebug();
#endif
	if (DictPtr[J] < ChnComp[CompIdx])
		return -1;
	if (DictPtr[J] > ChnComp[CompIdx])
		return 1;
	if (DictPtr[J + 1] < ChnComp[CompIdx + 1])
		return -1;
	if (DictPtr[J + 1] > ChnComp[CompIdx + 1])
		return 1;
	return 0;
}


/* Added: Joel Chen  Compound lookups */

#define CharEqual( I, Dict, Idx) (Dict[I] == ChnComp[Idx] && \
								  Dict[I+1] == ChnComp[Idx+1])
/*
 * Try to see if two compounds are equal.
 * Big5: space or '\0' signify the end of compound
 * HZ:   '~'
 */
int 			CompoundCmp(long I)
{
	int 			CIdx,
					Matches = 0;

	CIdx = CompIdx;
#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "\nCompoundCmp BEG\n");
	CloseDebug();
#endif
	for (; CIdx < COMP_CCNUM * 2 + 1 && ChnComp[CompIdx]; CIdx += 2) {
        if (CompDict[I+HzOff] == ' ')
			break;
        if (!CharEqual(I, CompDict, CIdx))
			return 0;
		I += 2;
		if (I >= NCompDictChars)
			break;
		Matches++;
	}
#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "CompoundCmp END %d\n", Matches);
	CloseDebug();
#endif
	if (Matches)
        return (CompDict[I+HzOff] == ' ' && CIdx > FIRST_BYTE_CLICK_POS );
	else
		return 0;
}

/*
 * Find all entries, which have their first chars match the first char
 * of the compound, in the dictionary for a match of the compound
 * we are looking for.
 */
int 			CompoundMatch(long I, int *Row)
{
	long			J = I;
	int 			Found = 0;

#ifdef _DEBUG_
	OpenDebug();
    fprintf(DebugPtr, "\nCompoundMatch BEG %ld\n", J);
	CloseDebug();
#endif
    if ( J < 0 ) {
        printf("Error! Bug ID 10000.\n");
        exit(1);
    }

	while (1) {
        while (J > 0 && CompDict[J] != '\n') J--;
		if (J > 0) J++;
        if (CharEqual(J+HzOff, CompDict, CompIdx)) {
			if (CompoundCmp(J+HzOff)) {
/*				  *I = J; */
#ifdef _DEBUG_
				OpenDebug();
				fprintf(DebugPtr, "CompoundCmp 1st found\n");
				CloseDebug();
#endif
				*Row = DoFound(J, CompDict, *Row);
				Found = 1;
			}
			J -= 2;
		} else
			break;
        if ( J <= 0 ) break;
	}
	J = I;
#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "CompoundMatch 2nd BEG\n");
	CloseDebug();
#endif
	while (1) {
        while (J < NCompDictChars && CompDict[J] != '\n') J++;
		if (J < NCompDictChars - 1) J++;
		else						break;
        if (CharEqual(J+HzOff, CompDict, CompIdx)) {
			if (CompoundCmp(J+HzOff)) {

#ifdef _DEBUG_
				OpenDebug();
				fprintf(DebugPtr, "CompoundMatch 2nd found\n");
				CloseDebug();
#endif
				*Row = DoFound(J, CompDict, *Row);
				Found = 1;
			}
			J += 2;
		} else
			break;
	}

#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "CompoundMatch not found\n");
	CloseDebug();
#endif
	return Found;
}

void			LookupComp(void)
{
	long			I;
	unsigned char	Tmp[81];
	int 			Found = 0,
					Row = PageSize + 1,
					i;

	strcpy(Tmp, BlankLine);
	WriteCopyRight();
#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "\nLookupComp BEG\n");
	for (i = 0; i < 10; i++)
		fputc(ChnComp[i], DebugPtr);
	CloseDebug();
#endif
	CompIdx = FIRST_BYTE_CLICK_POS;
	if (Lookup(&I, Dict, NDictChars) != 0)
		Row = DoFound(I, Dict, Row);
	else {
		fprintf(ShengziFilePtr, "not found.\n");
        sprintf(Tmp, "This character was not found: %s%c%c%s",
            HzOnMark, ChnComp[CompIdx], ChnComp[CompIdx + 1], HzOffMark );
		strcpy(BottomLine[0], Tmp);
		WriteLine(Row++, Tmp);
	}
#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "\nLookupComp SINGLE DONE\n");
	CloseDebug();
#endif
	for (CompIdx = 0; CompIdx <= FIRST_BYTE_CLICK_POS; CompIdx += 2) {
#ifdef _DEBUG_
        OpenDebug();
        fprintf(DebugPtr, "CompIdx: %d  char: %c%c\n", CompIdx,
            ChnComp[CompIdx], ChnComp[CompIdx+1]);
        CloseDebug();
#endif
        /* Search for the compound by comparing only the first character
         * first. */
        if (ChnComp[CompIdx] && Lookup(&I, CompDict, NCompDictChars))
            /* If first char matched, try to find a complete compound
             * which matches */
			Found += CompoundMatch(I, &Row);
	}
	if (!Found) {
		strcpy(BottomLine[Row - (PageSize + 1)],
			   "No compound was found.");
		WriteLine(Row++, "No compound was found.");
	}
	if (Row > PageSize) {
		for (i = Row - (PageSize + 1); i < KXLINES; i++)
			BottomLine[i][0] = 0;
	}
#ifdef _DEBUG_
	OpenDebug();
	fprintf(DebugPtr, "LookupComp Done.\n");
	CloseDebug();
#endif
}

/* Done Add: Joel Chen	Compound Lookups */


/* Change: Joel Chen  Lookup */

/* looks up the Chinese character ChnComp in the dictionary, and then
   displays the rest of that line of the dictionary (which has the
   Cantonese, Mandarin and English) */
int 			Lookup(long *IPtr, unsigned char HUGE * DictPtr, long NChars)
{
	unsigned char	C;
	int 			Cmp;
	long			I,
					Lo,
					Hi,
					Mid,
					OldMid;

	Lo = 0;
	Hi = NChars - 1;
	while (1) {
		OldMid = Mid;
		Mid = (Lo + Hi) / 2;
		if (Mid == OldMid)
			Mid = Hi;
		I = Mid;
        while (DictPtr[I] != '\n' && I > 0) I--;
        if (I > 0) I++;
		/* check for a match */
        Cmp = CheckMatch(I+HzOff, DictPtr);
		if (!Cmp) {
			*IPtr = I;
/*		   DoFound(I); */
			return 1;
		}
		if (Mid == Hi) {
			return 0;
		}
		if (Cmp < 0)
			Lo = Mid;
		else
			Hi = Mid;
	}
}

/* Done Change: Joel Chen  Lookup */


/* Change: Joel Chen  From GetChnChar to GetChnComp */

void			GetChnComp(void)
{
	unsigned char FAR *P;
	int 			I,
					J;
	int 			StartCol,
					StartRow,
					Begin,
					Dif;

	for (J = 0; J < COMP_CCNUM * 2 + 2; J++)
		ChnComp[J] = 0;
	J = FIRST_BYTE_CLICK_POS;
	StartRow = NewRow;

	/* Copy Clicked character into compound */
	P = CharLoc(StartRow, NewCol);
	ChnComp[J++] = *P;
	P += 2;
	ChnComp[J++] = *P;

	Dif = Begin = 0;
	/* Copy into last section of the compound */
	for (I = NewCol + 2; J < COMP_CCNUM * 2; I++) {
		P += 2;
		if (I == 80) {
			if (StartRow >= 20 || Dif)
				break;
			Begin = Dif = 2;
			P = CharLoc(++StartRow, 0);
			for (I = 0; I < 80; I++) {
				if (isspace(*P))
					P += 2;
				else
					break;
			}
			if (I == 80)
				break;
		}
		if (isspace(*P)) {
			if (!Dif && Begin != 1)
				Begin = 1;
			else if (Dif)
				break;
		} else if (Begin == 1)
			break;
		else
			Begin = 2;
		if (Begin == 2)
			ChnComp[J++] = *P;
	}
	/* Copy into first section of the compound */

	J = FIRST_BYTE_CLICK_POS - 1;
	Begin = Dif = 0;
	StartRow = NewRow, StartCol = NewCol - 1;
	P = CharLoc(StartRow, StartCol);

	for (I = StartCol; J >= 0; I--) {
		if (I == -1) {
			if (StartRow <= 0 || Dif)
				break;
			Begin = Dif = 2;
			P = CharLoc(--StartRow, 79);
			for (I = 79; I >= 0; I--) {
				if (isspace(*P))
					P -= 2;
				else
					break;
			}
			if (I < 0)
				break;
		}
		if (isspace(*P)) {
			if (!Dif && Begin != 1)
				Begin = 1;
			else if (Dif)
				break;
		} else if (Begin == 1)
			break;
		else
			Begin = 2;
		if (Begin == 2)
			ChnComp[J--] = *P;
		P -= 2;
	}

	/* Now copy the entire Clicked line */
	P = CharLoc(NewRow, 0);
	for (I = 0; I < 80; I++) {
		ClickedLine[I] = *P;
		P += 2;
	}
	for (I = 79; I >= 0; I--)
		if (!isspace(ClickedLine[I])) {
			I++;
			break;
		}
	ClickedLine[I] = 0;
	fprintf(ShengziFilePtr, "\n%s\n", ClickedLine);
	for (I = 0; I < NewCol; I++)
		fputc(' ', ShengziFilePtr);
	fprintf(ShengziFilePtr, "^^\n");
}

/* Done Change: Joel Chen  GetChnChar to GetChnComp */


int 			ButtonPress(void)
{
	InRegs.x.ax = 5;
	InRegs.x.bx = 0;
	int86(0x33, &InRegs, &OutRegs);
	return (OutRegs.x.ax == 1);
}

void			BlankScreen(void)
{
    textcolor(7);
    textbackground(0);
	clrscr();
    gettext(1, 1, 80, 25, VidPtr );
    _setcursortype( _SOLIDCURSOR );
}


void			Welcome(void)
{
	int 			I,
					H = 6;
	unsigned char	Tmp[81];

	BlankScreen();
	strcpy(Tmp, BlankLine);
    if (Big5)
        strcpy(Tmp, "                   Kuai Xue (־) Chinese Teaching Tool");
	else
		strcpy(Tmp, "                 Kuai Xue (~{?lQ'~}) Chinese Teaching Tool");
	WriteLine(H, Tmp);
	WriteLine(H + 3, "                     Copyright Norman S. Matloff, 1993");
	strcpy(Tmp, BlankLine);
	strcpy(Tmp, "Free use allowed for educational, noncommercial");
	strcat(Tmp, " purposes only.  No warranty");
	WriteLine(H + 7, Tmp);
	WriteLine(H + 8, "of any kind is made.");
	WriteLine(H + 10, "Help is available by typing the h key.");
	WriteLine(H + 13, "Type any character to continue.");
	getch();
	BlankScreen();
}


void			Help(void)
{
	int 			H = 1,
					I;
	unsigned char	Tmp[81];

	BlankScreen();
	strcpy(Tmp, BlankLine);
	strcpy(Tmp, "This program must be used in a Big5 environment such as");
	strcat(Tmp, " KC, or an Hz");
	WriteLine(H, Tmp);
	strcpy(Tmp, BlankLine);
	strcpy(Tmp, "environment such as ZWDOS.");
	WriteLine(H + 1, Tmp);
	WriteLine(H + 3, "Command line format:  kx [-h] infilename");
	strcpy(Tmp, BlankLine);
	strcpy(Tmp, "To do a lookup, simply click the mouse on the left half of");
	strcat(Tmp, " the Chinese");
	WriteLine(H + 5, Tmp);
	WriteLine(H + 6, "character.");
	strcpy(Tmp, BlankLine);
	strcpy(Tmp, "All characters you look up will be recorded in the file");
	strcat(Tmp, " shengzi.b5");
	WriteLine(H + 8, Tmp);
	strcpy(Tmp, BlankLine);
	strcpy(Tmp, "or shengzi.hz.  Print out this file for use as a handy");
	strcat(Tmp, " review sheet!");
	WriteLine(H + 9, Tmp);
	WriteLine(H + 11, "Commands:");
	WriteLine(H + 13, "b  --  move backward one screenfull");
	WriteLine(H + 14, "f  --  move forward one screenfull");
	WriteLine(H + 15, "r  --  refresh screen");
	WriteLine(H + 16, "h  --  print this help message");
	WriteLine(H + 17, "q  --  quit");
	WriteLine(H + 19, "Type any character to return");
	getch();
	BlankScreen();
	Refresh();
}

/* Added: Joel Chen  Read/SaveBookMark() */
void			CreateFileName(char *Buf, char *Name)
{
	int 			I;

	Buf[0] = 0;
	if (getenv("KXDIR")) {
		strcpy(Buf, getenv("KXDIR"));
		for (I = 0; I < strlen(Buf); I++)
			if (Buf[I] == '\\')
				Buf[I] = '/';
		strcat(Buf, "/");
	}
	strcat(Buf, Name);
}

char		   *BaseName(char *FN)
{
	char		   *BN = FN + strlen(FN) - 1;

	while (BN != FN && (*BN != '/' && *BN != '\\'))
		BN--;
	if (*BN == '/' || *BN == '\\')
		BN++;
	return BN;
}

void			SaveBookMark(char *FN)
{
	int 			L;
	char			buf[500];
	FILE		   *CFPtr;

	CreateFileName(buf, "kxbookmk.dat");
	gotoxy( 0, 24 );
    printf("\n\nBookmark file name: %s\n", buf);
	CFPtr = fopen(buf, "r+");
	if (CFPtr == NULL) {
		CFPtr = fopen(buf, "w+");
		if (CFPtr == NULL) {
			perror("fopen");
			return;
		}
	}
	FN = BaseName(FN);
	L = strlen(FN);
	rewind(CFPtr);
	while (fgets(buf, 499, CFPtr) != NULL) {
		if (strncmpi(buf, FN, L) == 0) {
			fseek(CFPtr, -(long) strlen(buf) - 1, SEEK_CUR);
			break;
		}
	}
	fprintf(CFPtr, "%s %05d\n", FN, TopLine);
	fclose(CFPtr);
}


int 			ReadBookMark(char *FN)
{
	int 			L,
					BookMark = 0;
	char			buf[500];
	char			Ans;
	FILE		   *CFPtr;

	CreateFileName(buf, "kxbookmk.dat");
	CFPtr = fopen(buf, "r");
	if (CFPtr == NULL)
		return 0;
	FN = BaseName(FN);
	L = strlen(FN);
	while (fgets(buf, 499, CFPtr) != NULL)
		if (strncmpi(buf, FN, L) == 0) {
			gotoxy( 0, 10 );
			printf("I found a bookmark for file %s.\n", FN);
			printf("Do you want to go to bookmark(y/n)? =>");
            fflush(stdout);
			Ans = getche();
			if (Ans == 'y' || Ans == 'Y')
				BookMark = atoi(buf + L);
			break;
		}
	fclose(CFPtr);
	BlankScreen();
	gotoxy( 0, 24 );
	return BookMark;
}

/* Done Added: Joel Chen  Read/SaveBookMark() */


void			ProcessKeyCmd(void)
{
	int 			Tmp;

	switch (getch()) {
	case 'b':
        if (TopLine >= PageSize - 1) {
            FileBackward( PageSize - 1 );
            TopLine -= PageSize - 1;
			Refresh();
		}
		break;
	case 'f':
        Tmp = TopLine + PageSize - 1;
		if (Tmp < NLines) {
            FileForward( PageSize - 1 );
			TopLine = Tmp;
			Refresh();
		}
		break;
	case 'h':
		Help();
		break;
	case 'r':
		BlankScreen();
		Refresh();
		break;
	case 'q':
		SaveBookMark(InputFileName);
		InitMouse();
		gotoxy( 0, 24 );
        _setcursortype( _SOLIDCURSOR );
		exit(0);
	}
    OldRow = OldCol = -1;
}

#ifdef _DEBUG_
void			OpenDebug(void)
{
	DebugPtr = fopen("debug", "a+");
}

void			CloseDebug(void)
{
	fclose(DebugPtr);
}
#endif

/* Change: Joel Chen main */

void			Usage(int argc)
{
	if (argc < 2) {
		printf("Usage: kx [-h] [-t] [-l] filename\n");
		printf("    Where -h tells kx to use Hz encoding.\n");
		printf("          -t tells kx to use text cursor as mouse cursor.\n");
        printf("          -l tells kx NOT to use 25th line of the display.\n");
		printf("\n    The -t option might be useful if the mouse cursor ");
		printf("\n    changes the Chinese characters.\n");
		exit(1);
	}
}

int 			ParseArgv(int argc, char **argv)
{
	int 			I,
					FNIdx = -1;
	for (I = 1; I < argc; I++) {
		if (argv[I][0] == '-') {
			switch (argv[I][1]) {
			case 'h':
			case 'H':
				Big5 = 0;
				break;
			case 't':
			case 'T':
				KXHandleMouseCursor = 1;
				break;
			case 'l':
			case 'L':
                Use25thLine = 0;
				break;
			default:
				printf("Unknown option: %c\n", argv[I][1]);
				break;
			}
		} else
			FNIdx = I;
	}
	return FNIdx;
}

void			ReadDicts(void)
{
	char			Buf[500];
	char		   *FN;

	CreateFileName(Buf, "CanMan");
	NDictChars = ReadDict(Dict, Buf);
	CreateFileName(Buf, "Compound");
	NCompDictChars = ReadDict(CompDict, Buf);
}

main(int argc, char **argv)
{
    int             TL,
                    I,
                    Tmp,
                    OldCurRow = -1,
					OldCurCol = -1;


	Usage(argc);
	InitMouse();
	FindVidStart();
	for (I = 0; I < 80; I++)
		BlankLine[I] = ' ';
	for (I = 0; I < KXLINES; I++)
		BottomLine[I][0] = 0;

	I = ParseArgv(argc, argv);
	if (I < 1) {
		printf("No file name given.\n");
		Usage(0);
	}
	InputFileName = argv[I];

	InFilePtr = fopen(InputFileName, "r");
	if (!InFilePtr) {
		printf("Input file not found:  %s.\n", argv[I]);
		exit(1);
	}
    if (Big5) {
		ShengziFilePtr = fopen("shengzi.b5", "a");
        HzOnMark[0] = HzOffMark[0] = 0;
    } else {
		ShengziFilePtr = fopen("shengzi.hz", "a");
		HzOff = 2;
	}
	ReadDicts();
	FormLines();
	Welcome();
	TopLine = 0;
	TL = ReadBookMark(argv[I]);
	FileGoto( TL );
	TopLine = TL;
	InitMouseCursor();
	Refresh();

	while (1) {
		if (kbhit())
			ProcessKeyCmd();
		if (KXHandleMouseCursor) {
			GetMousePosition();
			if (OldCurRow != NewRow || OldCurCol != NewCol) {
				OldCurRow = NewRow;
				OldCurCol = NewCol;
				gotoxy( NewCol+1, NewRow+1 );
			}
        } else
            ShowMouseCursor();
		if (kbhit())
			ProcessKeyCmd();
		if (ButtonPress()) {
			if (!KXHandleMouseCursor)
				GetMousePosition();
			if (NewRow != OldRow || NewCol != OldCol) {
				OldCol = NewCol;
				OldRow = NewRow;
				GetChnComp();
				LookupComp();
			}
		}
		if (kbhit())
			ProcessKeyCmd();
	}
}

/* Done Change: Joel Chen main */
